<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { salesDataHelper } from '~/services/sales.service';
import {
  CropInfinityHero,
  Faq,
  NextStepAlt,
} from '../components/common/index.vue';
import { SalesForm } from '../components/sales/index.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { getClient } from '../plugins/contentful';
import { getPageMetadata } from '~/common/meta';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    Faq,
    SalesForm,
    CropInfinityHero,
    NextStepAlt,
  },
  mixins: [LivePreviewMixin],
  async asyncData({ i18n }) {
    try {
      const { items } = await await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '1lSiI6H8VHumeqVJdcVdMG',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const sales = salesDataHelper(items);

      return { items, sales };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).sales,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) => (this.sales = salesDataHelper(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <section>
    <component
      :is="component.name"
      v-for="(component, index) in sales.components"
      :key="component.name + `-${index}`"
      :data="component.data"
    />
    <section v-if="sales.faq" class="slp-bg-surface-800">
      <faq :data="sales.faq" />
    </section>
    <NextStepAlt disable-secondary-button />
  </section>
</template>
